﻿/*
    Copyright © 2011 Cradlepoint, Inc. <www.cradlepoint.com>.  All rights reserved. 
    This file contains confidential information of Cradlepoint, Inc. and your 
    use of this file is subject to the Cradlepoint Software License Agreement 
    distributed with this file. Unauthorized reproduction or distribution of  
    this file is subject to civil and criminal penalties. 
*/
using System;
using System.Net.Sockets;
using System.Text;
using System.Windows;
using System.Xml;

namespace RouterControl
{
    /// <summary>
    /// Interaction logic for Athenticate.xaml
    /// </summary>
    public partial class Athenticate : Window
    {
        private String m_salt;
        private String m_password;
        private NetworkStream m_stream;

        public Athenticate(NetworkStream stream)
        {
            m_stream = stream;

            Request req = new Request(Command.Get, OpCode.Info);
            if (!req.Send(stream))
                return;

            Response response = new Response(stream);
            XmlDocument xmlDoc = response.getDoc();

            XmlNodeList list = xmlDoc.GetElementsByTagName("Salt");
            m_salt = list[0].InnerText;

            list = xmlDoc.GetElementsByTagName("HWAddr");
            m_password = list[0].InnerText;
            m_password = m_password.Substring(6);//Get last 6 digits of MAC address

            InitializeComponent();
            LoginButton.Focus();
            this.PasswordTextBox.Text = m_password;
            Owner = (MainWindow)Application.Current.MainWindow;
        }
        
        private String CreateHash(String salt, String password)
        {
            Byte[] digest = new Byte[17];
            StringBuilder sb = new StringBuilder(salt);
            //Append password to salt.
            sb.Append(password);
            //Pad with 1 to make 64 bytes
            sb.Append((char)0x01, 64 - sb.Length);

            //Crate MD5 hash
            System.Security.Cryptography.MD5 hasher = System.Security.Cryptography.MD5.Create();

            //Get has as byte array.
            Byte[] ba = hasher.ComputeHash(Encoding.ASCII.GetBytes(sb.ToString()));

            //sb.Clear(); .Net 4.5 only
            sb = new StringBuilder();

            //Convert to ASCII hex string.
            for (int i = 0; i < ba.Length; i++)
            {
                sb.Append(ba[i].ToString("x2"));
            }

            //Insert salt at beginning
            sb.Insert(0, salt);

            return sb.ToString();
        }

        private void LoginButton_Click(object sender, RoutedEventArgs e)
        {
            m_password = PasswordTextBox.Text;

            String hash = CreateHash(m_salt, m_password);
            Request req = new Request(Command.Auth, OpCode.None, hash);

            if (!req.Send(m_stream))
                return;

            Response response = new Response(m_stream);

            if (response.Result == ResultCode.OK)
                this.DialogResult = true;
            else
                this.DialogResult = false;
        }
    }
}
