﻿/*
    Copyright © 2011 Cradlepoint, Inc. <www.cradlepoint.com>.  All rights reserved. 
    This file contains confidential information of Cradlepoint, Inc. and your 
    use of this file is subject to the Cradlepoint Software License Agreement 
    distributed with this file. Unauthorized reproduction or distribution of  
    this file is subject to civil and criminal penalties. 
*/
using System;
using System.Windows;
using System.Windows.Controls;

namespace RouterControl
{

    /// <summary>
    /// Interaction logic for GetConfig.xaml
    /// </summary>
    public partial class GetConfig : Window
    {
        public GetConfig()
        {
            InitializeComponent();
            Owner = (MainWindow)Application.Current.MainWindow;
            AddButton.Focus();
        }

        public String ResponseText { get { return ConfigBox.Text; } }

        private void AddButton_Click(object sender, RoutedEventArgs e)
        {
            String name = ConfigSelect.SelectedItem.ToString();
            ConfigVariable request = (ConfigVariable)Enum.Parse(typeof(ConfigVariable), name);

            if (ConfigVariable.All == request)
            {
                foreach (ConfigVariable value in Enum.GetValues(typeof(ConfigVariable)))
                {
                    if (ConfigVariable.All == value)
                        continue;
                    
                    ConfigBox.Text += String.Format("<var name=\"{0}\"/>\n", value);
                }
            }
            else
            {
                ConfigBox.Text += String.Format("<var name=\"{0}\"/>\n", request);
                //ConfigBox.Text += String.Format("<var name=\"modem_settings[0].user_dial_script\"/>\n", request);
            }
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            ConfigBox.Text = String.Empty;
            DialogResult = false;
            Close();
        }

        private void DoneButton_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }

        private void ClearButton_Click(object sender, RoutedEventArgs e)
        {
            ConfigBox.Text = String.Empty;
        }

        private void Editable_Click(object sender, RoutedEventArgs e)
        {
            ConfigBox.IsReadOnly = (sender as CheckBox).IsChecked == true ? false : true;
        }
    }
}
