﻿/*
    Copyright © 2011 Cradlepoint, Inc. <www.cradlepoint.com>.  All rights reserved. 
    This file contains confidential information of Cradlepoint, Inc. and your 
    use of this file is subject to the Cradlepoint Software License Agreement 
    distributed with this file. Unauthorized reproduction or distribution of  
    this file is subject to civil and criminal penalties. 
*/
using System;
using System.Windows;

namespace RouterControl
{
    public enum DiagValues { All, MFG, PRD, SS, CARRID, CS, GSN}

    /// <summary>
    /// Interaction logic for GetDiagnostics.xaml
    /// </summary>
    public partial class GetDiagnostics : Window
    {
        public GetDiagnostics()
        {
            InitializeComponent();
            Owner = (MainWindow)Application.Current.MainWindow;
        }

        public String ResponseText { get { return ConfigBox.Text; } }

        private void AddButton_Click(object sender, RoutedEventArgs e)
        {
            String name = ConfigSelect.SelectedItem.ToString();
            DiagValues request = (DiagValues)Enum.Parse(typeof(DiagValues), name);
            //ConfigVariable request = (ConfigVariable)Enum.Parse(typeof(ConfigVariable), name);
            //if (Enum.TryParse(name, out request))//.Net 4.5 only
            {
                if (DiagValues.All == request)
                {
                    foreach (DiagValues value in Enum.GetValues(typeof(DiagValues)))
                    {
                        if (DiagValues.All == value)
                            continue;

                        ConfigBox.Text += String.Format("<var name=\"{0}\"/>\n", value);

                    }

                }
                else
                    ConfigBox.Text += String.Format("<var name=\"{0}\"/>\n", request);
            }
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            ConfigBox.Text = String.Empty;
            DialogResult = false;
            Close();
        }

        private void DoneButton_Click(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }

        private void ClearButton_Click(object sender, RoutedEventArgs e)
        {
            ConfigBox.Text = String.Empty;
        }
    }
}
